-------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

library UNISIM;
use UNISIM.vcomponents.all;

entity ps3e is port(

          clk050: in  std_logic;

          pbwest: in  std_logic;
          pbeast: in  std_logic;
          pbnord: in  std_logic;
          pbsued: in  std_logic;
          pbcent: in  std_logic;

          sw3   : in  std_logic;
          sw2   : in  std_logic;
          sw1   : in  std_logic;
          sw0   : in  std_logic;

          sdce  : out std_logic;
          mosi  : out std_logic;
          miso  : in  std_logic;
          sdck  : out std_logic;

          ps2c  : in  std_logic;
          ps2d  : in  std_logic;

          rxd   : in  std_logic;
          txd   : out std_logic;

          lcde  : out std_logic;
          lcdd  : out std_logic;
          lcdr  : out std_logic;
          lcdh  : out std_logic_vector(3 downto 0);

          led7  : out std_logic;
          led6  : out std_logic;
          led5  : out std_logic;
          led4  : out std_logic;
          led3  : out std_logic;
          led2  : out std_logic;
          led1  : out std_logic;
          led0  : out std_logic;

          vibl  : out std_logic;
          vign  : out std_logic;
          vird  : out std_logic;
          vihs  : out std_logic;
          vivs  : out std_logic;

          dcse  : out std_logic;
          dckp  : out std_logic;
          dckn  : out std_logic;
          dcke  : out std_logic;
          dlcp  : out std_logic;
          dldm  : out std_logic;
          ducp  : out std_logic;
          dudm  : out std_logic;
          dras  : out std_logic;
          dcas  : out std_logic;
          dwen  : out std_logic;
          dadr  : out   std_logic_vector(14 downto 0);
          ddat  : inout std_logic_vector(15 downto 0);

          spid1 : out   std_logic;
          spid2 : out   std_logic;
          spid3 : out   std_logic;
          spid4 : out   std_logic;
          spid5 : out   std_logic;
          fcen  : out   std_logic);

end ps3e;
architecture behps3e of ps3e is

signal clkdou   : std_logic;
signal clk100   : std_logic;
signal clk      : std_logic                     :=        '0';
signal phd      : std_logic                     :=        '0';
signal qhd      : std_logic_vector( 7 downto 0) := "00000001";
signal ctd      : std_logic_vector( 2 downto 0) :=      "000";
signal pre      : std_logic_vector( 7 downto 0) := x"00";
signal wrt      : std_logic_vector( 7 downto 0) := x"00";

signal ffb0,ffb1,ffb2,ffb3,ffb4,soft,setr,wst,xx1,xx2,wtrx,
       dcdriv,dcnz,rfhphas,rowphas,colphas,wtephas           : std_logic := '0';
signal ocse,oras,ocas,owen,ini,inidl,tra,trax                : std_logic := '1';

signal p01,p02,p03,p04,p05,p06,allp,pdn                      : std_logic;
signal oclk,eras,ecas,ewen,vclk,vclx                         : std_logic;

signal rd   : std_logic_vector( 3 downto 0) := "0000";
signal wr   : std_logic_vector( 1 downto 0) :=   "00";

signal datinh,datin   : std_logic_vector( 7 downto 0);
signal databuf        : std_logic_vector(15 downto 0);
signal adx            : std_logic_vector(18 downto 1);
signal ddat8,datind   : std_logic_vector( 7 downto 0);
signal iadr,kadr      : std_logic_vector(14 downto 0);

signal clx,cl2                     : std_logic := '1';
signal nrs,nrsdl                   : std_logic := '0';
signal cl1,rep,n3,n2,n1,n0         : std_logic;
signal datbus                      : std_logic_vector( 7 downto 0);
signal adrbus,ads,radr             : std_logic_vector(15 downto 0);
------------------------------------------------------------------------------------------------------
signal vpgd                               : std_logic := '0';
signal vdat                               : std_logic_vector( 7 downto 0);
signal vdomem,vadr                        : std_logic_vector(14 downto 0);
signal nachlad,vpg,vren                   : std_logic;
------------------------------------------------------------------------------------------------------
signal adsgk,adsck,adsrk,bram             : std_logic;
------------------------------------------------------------------------------------------------------
signal hs1 ,dtast,sden                    : std_logic;                      -- hs4 ,hs5 ,hs6 ,hs7
signal rep1,repk                          : std_logic;                      -- rep4,rep5,rep6,rep7
signal dat1,zeich                         : std_logic_vector( 7 downto 0);  -- dat4,dat5,dat6,dat7
------------------------------------------------------------------------------------------------------
signal badr                               : std_logic_vector(14 downto 0);
signal bdat                               : std_logic_vector( 7 downto 0);
signal bwen,bren                          : std_logic;
------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------
component vdogen port(

  trax      : in  std_logic;
  vpg       : in  std_logic;
  vclk      : in  std_logic;
  bufpixel  : in  std_logic_vector( 7 downto 0);
  vdomem    : out std_logic_vector(14 downto 0);
  nachlad   : out std_logic;
  vibl      : out std_logic;
  vign      : out std_logic;
  vird      : out std_logic;
  vihs      : out std_logic;
  vivs      : out std_logic);

end component;
----------------------------------------------------------------------------------------------------
component cpu port(

      cl0  : in  std_logic;
      cl1  : in  std_logic;
      nrs  : in  std_logic;
      rep  : in  std_logic;

      n3   : out std_logic;
      n2   : out std_logic;
      n1   : out std_logic;
      n0   : out std_logic;

      datbus : inout std_logic_vector ( 7 downto 0);
      adrbus : inout std_logic_vector (15 downto 0));

end component;
----------------------------------------------------------------------------------------------------
component ram32 port(

       cclk  : in  std_logic;
       cena  : in  std_logic;
       cadr  : in  std_logic_vector(14 downto 0);
       cdat  : in  std_logic_vector( 7 downto 0);

       vclk  : in  std_logic;
       vena  : in  std_logic;
       vadr  : in  std_logic_vector(14 downto 0);
       vdat  : out std_logic_vector( 7 downto 0));

end component;
----------------------------------------------------------------------------------------------------
component allh port(

       cl1    : in  std_logic;
       nrs    : in  std_logic;
       dtast  : in  std_logic;
       n0     : in  std_logic;
       n1     : in  std_logic;
       n2     : in  std_logic;
       n3     : in  std_logic;
       ads    : in  std_logic_vector(15 downto 0);
       zeich  : in  std_logic_vector( 7 downto 0);
       dat1   : in  std_logic_vector( 7 downto 0);
--       dat4   : in  std_logic_vector( 7 downto 0);
--       dat5   : in  std_logic_vector( 7 downto 0);
--       dat6   : in  std_logic_vector( 7 downto 0);
--       dat7   : in  std_logic_vector( 7 downto 0);
       hs1    : out std_logic;
--       hs4    : out std_logic;
--       hs5    : out std_logic;
--       hs6    : out std_logic;
--       hs7    : out std_logic;
       adx    : out std_logic_vector(18 downto 1);
       datinh : out std_logic_vector( 7 downto 0);
       vpg    : out std_logic;
       bram   : out std_logic;
       adsgk  : out std_logic;
       adsck  : out std_logic;
       adsrk  : out std_logic);

end component;
----------------------------------------------------------------------------------------------------
component keybd port(

  nrs    : in  std_logic;
  cl1    : in  std_logic;
  cl2    : in  std_logic;

  adsgk  : in  std_logic;
  adsck  : in  std_logic;
  adsrk  : in  std_logic;

  ps2c   : in  std_logic;
  ps2d   : in  std_logic;

  repk   : out std_logic;
  dtast  : out std_logic;
  zeich  : out std_logic_vector(7 downto 0));

end component;
----------------------------------------------------------------------------------------------------
component display port(

  nrs    : in  std_logic;
  cl1    : in  std_logic;
  cl2    : in  std_logic;

  key    : in  std_logic;
  repk   : in  std_logic;

  lcde   : out std_logic;
  lcdd   : out std_logic;
  lcdh   : out std_logic_vector(3 downto 0));

end component;
----------------------------------------------------------------------------------------------------
component expa1 port(

          nrs   : in  std_logic;
          cl1   : in  std_logic;
          cl2   : in  std_logic;
          hs    : in  std_logic;
          ads   : in  std_logic_vector(15 downto 0);
          dat   : out std_logic_vector( 7 downto 0);
          rep   : out std_logic;

          rxd   : in  std_logic;
          txd   : out std_logic;
          din   : in  std_logic;
          dou   : out std_logic;
          dck   : out std_logic;
          dce   : out std_logic);

end component;
----------------------------------------------------------------------------------------------------
-- component expa4 port(
--
--           nrs   : in  std_logic;
--           cl1   : in  std_logic;
--           cl2   : in  std_logic;
--           hs    : in  std_logic;
--           ads   : in  std_logic_vector(15 downto 0);
--           dat   : out std_logic_vector( 7 downto 0);
--           rep   : out std_logic
--
--           --    insert io-pin
--           --    insert io-pin
--
--           );
--
-- end component;
----------------------------------------------------------------------------------------------------
begin

ic0 : BUFG    port map (I => clkdou, O => clk100);
ic1 : BUFG    port map (I => vclx,   O => vclk  );
ic2 : BUFG    port map (I => clx,    O => cl1   );

idm : DCM_SP  generic map (CLKDV_DIVIDE => 2.0, CLKFX_DIVIDE => 1, CLKFX_MULTIPLY => 2,
              CLKIN_DIVIDE_BY_2 => FALSE, CLKIN_PERIOD => 20.0, CLKOUT_PHASE_SHIFT => "NONE",
              CLK_FEEDBACK => "NONE", DESKEW_ADJUST => "SOURCE_SYNCHRONOUS", DLL_FREQUENCY_MODE
              => "LOW", DUTY_CYCLE_CORRECTION => TRUE, PHASE_SHIFT => 0, STARTUP_WAIT => FALSE)

              port map (CLKFX => clkdou, CLKFB => '0', CLKIN => clk050,
              PSCLK =>'0', PSEN => '0', PSINCDEC => '0', RST => '0');

i00 : vdogen  port map(trax,vpgd,vclk,vdat,vdomem,nachlad,vibl,vign,vird,vihs,vivs);

i01 : cpu     port map(cl1,cl1,nrs,rep,n3,n2,n1,n0,datbus,adrbus);

i02 : ram32   port map(cl1,bwen,badr,datbus,vclk,vren,vadr,vdat);

iah : allh    port map(cl1,nrs,dtast,n0,n1,n2,n3,ads,zeich,dat1,
                       hs1,adx,datinh,vpg,bram,adsgk,adsck,adsrk);

i03 : keybd   port map(nrs,cl1,cl2,adsgk,adsck,adsrk,ps2c,ps2d,repk,dtast,zeich);

i04 : display port map(nrs,cl1,cl2,zeich(7),repk,lcde,lcdd,lcdh);

i05 : expa1   port map(nrs,cl1,cl2,hs1,ads,dat1,rep1,rxd,txd,miso,mosi,sdck,sden);

-- i06 : expa4   port map(nrs,cl1,cl2,hs4,ads,dat4,rep4);

-- i07 : expa5   port map(nrs,cl1,cl2,hs5,ads,dat5,rep5);

-- i08 : expa6   port map(nrs,cl1,cl2,hs6,ads,dat6,rep6);

-- i09 : expa7   port map(nrs,cl1,cl2,hs7,ads,dat7,rep7);
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
spid1 <= '1';
spid2 <= '1';
spid3 <= '1';
spid4 <= '0';
spid5 <= '0';
fcen  <= '1';
lcdr  <= '0';

led7 <= dtast;
led6 <= ffb2 or ffb3 or ffb4;
led5 <= not nrs;
led4 <= rep;
led3 <= not sden;
led2 <= not miso;
led1 <= '0';
led0 <= sw3;

sdce <= sden;

dcke <= pre(7);
dckp <= clk100;
dckn <= not clk100;

ads  <= adrbus;
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
writeclk : process(clk100)
begin
if clk100'event and clk100 = '0' then clk <= not clk; end if;
end process writeclk;
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
writepre : process(clk) begin
if clk'event and clk = '0' then if pre(7) = '0' then pre <= std_logic_vector(unsigned(pre)+1);
end if; end if; end process writepre;
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
writephd : process(clk)
begin
if clk'event and clk = '0' then if pre(7) = '1' then phd <= not phd;
end if; end if; end process writephd;

vclx <= not phd;
-----------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------
writeqhd : process(clk)
begin
if clk'event and clk = '0' then if phd = '1' then qhd <= qhd(6 downto 0) & qhd(7); end if; end if;
end process writeqhd;
-----------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------
writectd : process(clk)
begin
if clk'event and clk = '0' then if (qhd(7) and phd) = '1'
                           then ctd <= std_logic_vector(unsigned(ctd)+1); end if; end if;
end process writectd;
-----------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------
writecl2 : process(clk) begin if clk'event and clk = '0'
                        then if (qhd(4) and phd) = '1' then cl2 <= not ctd(0);
                        end if; end if; end process writecl2;

writecl1 : process(clk) begin if clk'event and clk ='0'
                        then if ((qhd(1) or qhd(7)) and phd) = '1' then clx <= qhd(7);
                        end if; end if; end process writecl1;
-----------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------
writeini   : process(clk) begin if clk'event and clk = '0' then if (pdn and phd) = '1' then
                          ini <= '0'; end if; end if; end process writeini;

writeinidl : process(clk) begin if clk'event and clk = '0' then if phd = '1' then
                          inidl <= ini; end if; end if; end process writeinidl;
------------------------------------------------------------------------------------
combctdphas : process(ctd,qhd)
variable s2,s1,s0,z2,z1,z0 : std_logic;
begin
s2 := ctd(2); s1 := ctd(1); s0 := ctd(0);
z2 := not s2; z1 := not s1; z0 := not s0;

p01 <= z2 and z1 and s0 and qhd(7);
p02 <= z2 and s1 and z0 and qhd(7);
p03 <= z2 and s1 and s0 and qhd(7);
p04 <= s2 and z1 and z0 and qhd(7);
p05 <= s2 and z1 and s0 and qhd(7);
p06 <= s2 and s1 and z0 and qhd(7);
pdn <= s2 and s1 and s0 and qhd(7);

end process combctdphas;
-----------------------------------------------------------------------------------------------------------
allp <= p01 or p02 or p03 or p04 or p05 or p06;
-----------------------------------------------------------------------------------------------------------
eras <= not (rowphas or rfhphas or (ini and allp                     ));
ecas <= not (colphas or rfhphas or (ini and allp and not (p01 or p04)));
ewen <= not (wtephas            or (ini and allp and not (p05 or p06)));
-----------------------------------------------------------------------------------------------------------
writecomphas : process(clk)
begin
if clk'event and clk = '0' then if phd = '1' then
                           rowphas <= not ini and qhd(2) and not ctd(0) and n3;
                           colphas <= not ini and qhd(3) and not ctd(0) and n3;
                           wtephas <= not ini and qhd(3) and not ctd(0) and n3 and not n2 and (n1 or n0);
                           rfhphas <= not ini and qhd(1) and     ctd(0) ;                 end if; end if;
end process writecomphas;
-----------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------
writeocse : process(clk) begin if clk'event and clk = '1' then
                         ocse <= phd;
                         end if; end process writeocse;

writecmd  : process(clk) begin if clk'event and clk = '0' then
                         oras <= eras or phd; ocas <= ecas or phd; owen <= ewen or phd;
                         end if; end process writecmd;

writecommand : process(clk100) begin   if clk100'event and clk100 = '0' then
                               dcse <= ocse; dras <= oras; dcas <= ocas; dwen <= owen;
                               end if; end process writecommand;

writevect    : process(clk100) begin   if clk100'event and clk100 = '0' then
               rd(3 downto 1) <= rd(2 downto 0); rd(0) <= not (ocas or ocse);
               wr(         1) <= wr(         0); wr(0) <= not (owen or ocse);
               end if; end process writevect;
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
iadr(14) <= '0';
iadr(13) <= ini and  p02;
iadr(12) <= '0';
iadr(11) <= '0';
iadr(10) <= ini and (p01 or p04);
iadr(9)  <= '0';
iadr(8)  <= ini and  p03;
iadr(7)  <= '0';
iadr(6)  <= '0';
iadr(5)  <= ini and  p03;
iadr(4)  <= '0';
iadr(3)  <= '0';
iadr(2)  <= '0';
iadr(1)  <= ini and  p03;
iadr(0)  <= '0';
------------------------------------------------------------------------------------------
dadr <= iadr or kadr;
------------------------------------------------------------------------------------------
combkadr : process(rowphas,colphas,adx)
variable   oo                           : std_logic;
variable   vrowphas,vcolphas            : std_logic_vector(14 downto 0);
begin
oo := rowphas; vrowphas := oo & oo & oo & oo & oo & oo & oo & oo & oo & oo & oo & oo & oo & oo & oo;
oo := colphas; vcolphas := oo & oo & oo & oo & oo & oo & oo & oo & oo & oo & oo & oo & oo & oo & oo;

kadr <= (vrowphas and ("00000" & adx(13 downto 10) & adx(6 downto 1))) or
        (vcolphas and ("00001" & adx(18 downto 14) & adx(9 downto 7) & "00"));

end process combkadr;
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
writedcdriv : process(clk)  begin if clk'event and clk = '1' then if ocse = '0' then
                            dcdriv <= wtephas; end if; end if;
                            end process writedcdriv;

writedcnz : process(clk100) begin if clk100'event and clk100 = '0' then
                            dcnz <= wr(0) or wr(1); end if;
                            end process writedcnz;

oclk <= clk100 when dcnz = '1' else '0';

dlcp <= oclk when dcdriv = '1' else 'Z';
ducp <= oclk when dcdriv = '1' else 'Z';
------------------------------------------------------------------------------------------
dldm <=     ads(0);
dudm <= not ads(0);

ddat8 <= datbus;

ddat  <= ddat8 & ddat8 when dcdriv = '1' else "ZZZZZZZZZZZZZZZZ";
------------------------------------------------------------------------------------------
writedatabuf : process(clk100) begin
if clk100'event and clk100 = '0' then if rd(3) = '1' then databuf <= ddat; end if; end if;
end process writedatabuf;

datind <= databuf(15 downto 8) when ads(0)= '1' else databuf(7 downto 0);

datin  <= bdat when tra = '1' else datind;
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
bwen <= not tra and n3 and not n2 and (n1 or n0) and bram;

badr <= (ads(14) xor vpg) & ads(13 downto 0);
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
vadr <= ads(14 downto 0) when trax = '1' else vdomem;

vren <= bren when trax = '1' else nachlad;
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
writexx1  : process(vclk) begin
if vclk'event and vclk = '0' then xx1 <= not ctd(0) and qhd(7);
end if; end process writexx1;

writewtrx : process(vclk) begin
if vclk'event and vclk = '1' then wtrx <= xx1;
end if; end process writewtrx;

writetrax : process(vclk) begin
if vclk'event and vclk = '1' then if wtrx = '1' then trax <= tra;
end if; end if; end process writetrax;
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
writexx2  : process(vclk) begin
if vclk'event and vclk = '0' then xx2 <= not ctd(0) and qhd(4);
end if; end process writexx2;

writebren : process(vclk) begin
if vclk'event and vclk = '1' then bren <= xx2;
end if; end process writebren;

writebdat : process(cl1) begin
if cl1'event and cl1 = '1' then if (cl2 and tra)= '1' then bdat <= vdat;
end if; end if; end process writebdat;
-------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------
radr   <= x"4cc0" when tra = '1' else x"17e8";

adrbus <= radr                                when nrsdl                           = '0' else "ZZZZZZZZZZZZZZZZ";

datbus <= wst & "000" & sw3 & sw2 & sw1 & sw0 when nrsdl                           = '0' else "ZZZZZZZZ";

datbus <= datin                               when (n3 and (n2 or not (n1 or n0))) = '1' else "ZZZZZZZZ";

datbus <= datinh                              when (not n3 and not n2 and n0)      = '1' else "ZZZZZZZZ";

rep    <= repk or rep1; -- or rep4 or rep5 or rep6 or rep7;
-------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------
writevpgd : process(clk) begin if clk'event and clk = '0' then vpgd <= vpg; end if; end process writevpgd;
-------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------
writeffbx  : process(cl1) begin if cl1'event and cl1 = '1' then
             ffb2 <= pbnord; ffb3 <= pbwest; ffb4 <= pbcent; end if; end process writeffbx;
-------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------
writetast  : process(cl1) begin if cl1'event and cl1 = '1' then
             ffb1 <= pbeast; ffb0 <= pbsued; end if; end process writetast;

writesoft  : process(cl1) begin if cl1'event and cl1 = '1' then
             soft <= not n3 and not n2 and n1 and not n0; end if; end process writesoft;

writetra   : process(cl1) begin if cl1'event and cl1 = '1' then if soft = '1' then
             tra <= '0'; end if; end if; end process writetra;

writesetr  : process(cl2) begin if cl2'event and cl2 = '0' then
             setr <= ffb0 or soft; end if; end process writesetr;
-------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------
writewrt   : process(cl1) begin if cl1'event and cl1 = '1' then if (inidl or wrt(7)) = '0' then
             wrt <= std_logic_vector(unsigned(wrt)+1); end if; end if; end process writewrt;

writenrs   : process(cl2,setr) begin if setr = '1' then nrs <= '0';
             elsif cl2'event and cl2 = '1' then if (ffb1 or wrt(6)) = '1' then nrs <= '1';
             end if; end if; end process writenrs;

writewst   : process(cl1) begin if cl1'event and cl1 = '0' then if (nrs and not tra) = '1' then wst <= '1';
             end if; end if; end process writewst;

writenrsdl : process(cl1) begin
             if cl1'event and cl1 = '0' then nrsdl <= nrs; end if; end process writenrsdl;
-------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------
end behps3e;
-------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity vdogen is port(

  trax      : in  std_logic;
  vpg       : in  std_logic;
  vclk      : in  std_logic;
  bufpixel  : in  std_logic_vector( 7 downto 0);
  vdomem    : out std_logic_vector(14 downto 0);
  nachlad   : out std_logic;
  vibl      : out std_logic;
  vign      : out std_logic;
  vird      : out std_logic;
  vihs      : out std_logic;
  vivs      : out std_logic);

end vdogen;
architecture behvdogen of vdogen is

signal vpgv          : std_logic := '0';
signal ffhs,ffvs     : std_logic := '1';
signal respuls       : std_logic := '0';
signal setpuls       : std_logic;

signal getphas,ladphas,aoutphas,boutphas,swihct,maxhcp,maxhct,maxvct : std_logic;

signal pixel,neupixel  : std_logic_vector(7 downto 0);

signal memct           : std_logic_vector(13 downto 0) := "00000000000000";

signal hcp             : std_logic_vector( 9 downto 0) := "0000001000";
signal hct,vct         : std_logic_vector( 9 downto 0) := "0000000000";
signal neuhcp          : std_logic_vector( 9 downto 0);
signal neuhct,neuvct   : std_logic_vector( 9 downto 0);

begin

vihs    <= ffhs;
vivs    <= ffvs;
nachlad <= getphas;

vdomem  <= (not vpgv) & memct(5 downto 0) & memct(13 downto 6);
------------------------------------------------------------------------------------------------------------

neuhcp <= "0000000000" when maxhcp = '1' else std_logic_vector(unsigned(hcp) + 1);
neuhct <= "0000000000" when maxhct = '1' else std_logic_vector(unsigned(hct) + 1);
neuvct <= "0000000000" when maxvct = '1' else std_logic_vector(unsigned(vct) + 1);
------------------------------------------------------------------------------------------------------------

writehcp : process(vclk) begin
if vclk'event and vclk = '1' then if trax = '0' then hcp <= neuhcp;
end if; end if; end process writehcp;

writehct : process(vclk) begin
if vclk'event and vclk = '1' then if trax = '0' then hct <= neuhct;
end if; end if; end process writehct;

writevct : process(vclk) begin
if vclk'event and vclk = '1' then if swihct = '1' then vct <= neuvct;
end if; end if; end process writevct;

swihct <= hct(9) and not hct(8) and     hct(7) and not hct(6) and not hct(5) and not hct(4)
                                and not hct(3) and not hct(2) and not hct(1) and not hct(0);

maxhcp <= hcp(9) and     hcp(8) and not hcp(7) and not hcp(6) and not hcp(5) and     hcp(4)
                                and     hcp(3) and     hcp(2) and     hcp(1) and     hcp(0);

maxhct <= hct(9) and     hct(8) and not hct(7) and not hct(6) and not hct(5) and     hct(4)
                                and     hct(3) and     hct(2) and     hct(1) and     hct(0);

maxvct <= vct(9) and not vct(8) and not vct(7) and not vct(6) and not vct(5) and not vct(4)
                                and     vct(3) and not vct(2) and not vct(1) and not vct(0);
------------------------------------------------------------------------------------------------------------
getphas <= not (hcp(9) or hcp(2) or hcp(1) or hcp(0)) and  not vct(9) and (vct(8) xor vct(7));
ladphas <= not (hct(9) or hct(2) or hct(1) or hct(0)) and  not vct(9) and (vct(8) xor vct(7));
------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
writepixel : process(vclk) begin
if vclk'event and vclk = '1' then pixel <= neupixel;
end if; end process writepixel;

neupixel <= (pixel(6 downto 0) & '0') when ladphas = '0' else not bufpixel;
------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
writememct  : process(vclk) begin if vclk'event and vclk = '1' then if getphas = '1'
 then memct <= std_logic_vector(unsigned(memct)+1); end if; end if;
 end process writememct;

writevpgv   : process(vclk) begin if vclk'event and vclk = '1' then if ffvs = '0'
 then vpgv <= vpg; end if; end if;
 end process writevpgv;
------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
 setpuls <= hct(9) and not hct(8) and not hct(7) and     hct(6) and not hct(5) and     hct(4)
                                  and not hct(3) and not hct(2) and not hct(1) and not hct(0);

writerespuls : process(vclk) begin if vclk'event and vclk = '1' then
 respuls <= hct(9) and not hct(8) and     hct(7) and not hct(6) and     hct(5) and     hct(4)
                                  and not hct(3) and not hct(2) and not hct(1) and not hct(0);
 end if; end process writerespuls;
------------------------------------------------------------------------------------------------------------
writeffhs : process(vclk,respuls) begin if respuls = '1' then ffhs <= '1';
        elsif vclk'event and vclk = '1' then if setpuls = '1' then ffhs <= '0';
 end if; end if; end process writeffhs;
------------------------------------------------------------------------------------------------------------
writeffvs : process(vclk) begin
 if vclk'event and vclk = '1' then
 ffvs <= not (not vct(9) and     vct(8) and     vct(7) and     vct(6) and     vct(5)
                         and     vct(4) and not vct(3) and     vct(2) and     vct(1));
 end if; end process writeffvs;
------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
writeaoutphas : process(vclk) begin if vclk'event and vclk = '1' then
 aoutphas <= not hct(9) and not vct(9) and (vct(8) xor vct(7));
 end if; end process writeaoutphas;

writeboutphas : process(vclk) begin if vclk'event and vclk = '1' then
 boutphas <= (not hct(9) or not (hct(7) or hct(6) or hct(5))) and not vct(9) and ((vct(8) xor vct(7))
 or (not vct(8) and not vct(7) and vct(6) and vct(5)) or (vct(8) and vct(7) and not vct(6) and not vct(5)));
 end if; end process writeboutphas;
------------------------------------------------------------------------------------------------------------
comboutput  : process(aoutphas,boutphas,pixel(7)) begin

 if aoutphas = '1' then vign <= pixel(7); vird <= pixel(7); vibl <= '0';

 elsif boutphas = '1' then vign <= '0'; vird <= '0'; vibl <= '1';
 else                      vign <= '0'; vird <= '0'; vibl <= '0'; end if;
 end process comboutput;
------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
end behvdogen;
------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity display is port(

  nrs    : in  std_logic;
  cl1    : in  std_logic;
  cl2    : in  std_logic;

  key    : in  std_logic;
  repk   : in  std_logic;

  lcde   : out std_logic;
  lcdd   : out std_logic;
  lcdh   : out std_logic_vector(3 downto 0));

end display;
architecture behdisplay of display is

signal repdl,runzeit,accp                 : std_logic;
signal zeit,neuzeit                       : std_logic_vector(31 downto 0);

signal zeitbuf,neuzeitbuf                 : std_logic_vector(31 downto 0);
signal xchar                              : std_logic_vector( 7 downto 0);

signal init,wart,ct0                      : std_logic                     := '1';
signal ctr                                : std_logic_vector(14 downto 0) := "000000000000000";

signal phas1,phas2,phas3,phas4,phas5,phas6,phas7,phas8,phas5b,phas6b,phas7b,phas8b : std_logic;
signal bit0,bit1,bit2,bit3,einit                                                   : std_logic;
signal phash,phasl,hphas,lphas,ephas                                               : std_logic;
----------------------------------------------------------------------------------------------------------------
begin

writerepdl : process(cl1) begin if cl1'event and cl1 = '1' then repdl <= repk;
end if; end process writerepdl;

accp <= repdl and key;

writerunzeit : process(nrs,cl1) begin if nrs = '0' then runzeit <= '1';
elsif cl1'event and cl1 = '1' then if (cl2 and ((repk and not repdl) or accp)) = '1' then runzeit <= accp;
end if; end if; end process writerunzeit;

writezeit : process(nrs,cl1) begin if nrs = '0' then zeit <= x"ffffffff";
elsif cl1'event and cl1 = '1' then if cl2 = '1' then zeit <= neuzeit;
end if; end if; end process writezeit;

combneuzeit : process(zeit,accp,runzeit)
variable vrunzeit,vaccp  : std_logic_vector(31 downto 0);
variable o               : std_logic; begin

o := accp;     vaccp    := o & o & o & o & o & o & o & o & o & o & o & o & o & o & o & o &
                           o & o & o & o & o & o & o & o & o & o & o & o & o & o & o & o;
o := runzeit;  vrunzeit := o & o & o & o & o & o & o & o & o & o & o & o & o & o & o & o &
                           o & o & o & o & o & o & o & o & o & o & o & o & o & o & o & o;

neuzeit <= not vaccp and ((vrunzeit and std_logic_vector(unsigned(zeit)+1)) or (not vrunzeit and zeit));
end process combneuzeit;
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
latchwart : process(nrs) begin
if nrs = '1' then wart <= '0'; end if;
end process latchwart;
----------------------------------------------------------------------------------------------------------------
writect0 : process(cl1) begin
if cl1'event and cl1 = '1' then if wart = '0' then ct0 <= cl2; end if; end if;
end process writect0;

writectr : process(cl1) begin
if cl1'event and cl1 = '1' then if ct0 = '0' then ctr <= std_logic_vector(unsigned(ctr)+1); end if; end if;
end process writectr;
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
latchinit : process(ctr(14)) begin
if ctr(14) = '1' then init <= '0'; end if;
end process latchinit;
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------

phas1  <= '1' when ctr(13 downto 0) = ('0' & x"03d" & '0') else '0';

phas2  <= '1' when ctr(13 downto 0) = ('1' & x"43d" & '0') else '0';

phas3  <= '1' when ctr(13 downto 0) = ('1' & x"4fd" & '0') else '0';

phas4  <= '1' when ctr(13 downto 0) = ('1' & x"53d" & '0') else '0';

phas5  <= '1' when ctr(13 downto 0) = ('1' & x"57d" & '0') else '0';
phas5b <= '1' when ctr(13 downto 0) = ('1' & x"57f" & '0') else '0';

phas6  <= '1' when ctr(13 downto 0) = ('1' & x"5bd" & '0') else '0';
phas6b <= '1' when ctr(13 downto 0) = ('1' & x"5bf" & '0') else '0';

phas7  <= '1' when ctr(13 downto 0) = ('1' & x"5fd" & '0') else '0';
phas7b <= '1' when ctr(13 downto 0) = ('1' & x"5ff" & '0') else '0';

phas8  <= '1' when ctr(13 downto 0) = ('1' & x"63d" & '0') else '0';
phas8b <= '1' when ctr(13 downto 0) = ('1' & x"63f" & '0') else '0';

----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
bit0  <= init and (phas1  or phas2  or phas3                     or phas8b);
bit1  <= init and (phas1  or phas2  or phas3  or phas4  or phas5 or phas6b);
bit2  <= init and (phas6b or phas7b);
bit3  <= init and (phas5b or phas7b);

einit <= init and (phas1 or phas2 or phas3  or phas4  or phas5  or phas6 or
                   phas7 or phas8 or phas5b or phas6b or phas7b or phas8b);
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
writezeitbuf : process(cl1) begin if cl1'event and cl1 = '1' then
if (ctr(6) or ctr(5) or ctr(4) or ctr(3) or ctr(2) or ctr(1) or ctr(0) or ct0) = '0' then zeitbuf <= neuzeitbuf;
end if; end if; end process writezeitbuf;

neuzeitbuf <= zeitbuf(27 downto 0) & "0000" when (ctr(9) or ctr(8) or ctr(7)) = '1' else zeit;

xchar <= "0011" & zeitbuf(31 downto 28) when (zeitbuf(31) and (zeitbuf(30) or zeitbuf(29))) = '0' else
         "0110" & std_logic_vector(unsigned(zeitbuf(31 downto 28)) + 7);
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
phash <= not init and (not ctr(10) and not ctr(2));
phasl <= not init and (not ctr(10) and     ctr(2));

hphas <= not init and (    ctr(10) and not ctr(2));
lphas <= not init and (    ctr(10) and     ctr(2));

ephas <= not init and (    ctr(6)  and not ctr(5) and not ctr(4) and not ctr(3) and not ctr(1) and not ctr(0));
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
lcdd  <= not init and      ctr(10);
----------------------------------------------------------------------------------------------------------------
lcdh  <= (bit3 & bit2 & bit1 & bit0) or

         ("1000"            and (phash & phash & phash & phash)) or
         ("0100"            and (phasl & phasl & phasl & phasl)) or

         (xchar(7 downto 4) and (hphas & hphas & hphas & hphas)) or
         (xchar(3 downto 0) and (lphas & lphas & lphas & lphas)) ;
----------------------------------------------------------------------------------------------------------------
writelcde : process(cl1,ct0) begin
if ct0 = '0' then lcde <= '0'; elsif cl1'event and cl1 = '0' then lcde <= einit or ephas;
end if; end process writelcde;
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
end behdisplay;
---------------
---------------
